Index: vm/vm_page.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_page.c,v
retrieving revision 1.164
diff -u -r1.164 vm_page.c
--- vm/vm_page.c	2001/05/24 07:22:26	1.164
+++ vm/vm_page.c	2001/07/04 02:54:17
@@ -148,7 +148,6 @@
  *
  *	Add a new page to the freelist for use by the system.
  *	Must be called at splhigh().
- *	Must be called with the vm_mtx held.
  */
 vm_page_t
 vm_add_new_page(pa)
@@ -156,7 +155,8 @@
 {
 	vm_page_t m;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	++cnt.v_page_count;
 	++cnt.v_free_count;
 	m = PHYS_TO_VM_PAGE(pa);
@@ -362,8 +362,9 @@
 	register vm_pindex_t pindex;
 {
 	register struct vm_page **bucket;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if (m->object != NULL)
 		panic("vm_page_insert: already inserted");
 
@@ -422,8 +423,9 @@
 	vm_page_t m;
 {
 	vm_object_t object;
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
 	if (m->object == NULL)
 		return;
 
@@ -487,8 +489,6 @@
  *	an interrupt makes a change, but the generation algorithm will not 
  *	operate properly in an SMP environment where both cpu's are able to run
  *	kernel code simultaneously.
- *	NOTE: under the giant vm lock we should be ok, there should be
- *	no reason to check vm_page_bucket_generation
  *
  *	The object must be locked.  No side effects.
  *	This routine may not block.
@@ -604,7 +604,7 @@
 	int queue = m->queue;
 	struct vpgqueues *pq;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if (queue != PQ_NONE) {
 		m->queue = PQ_NONE;
 		pq = &vm_page_queues[queue];
@@ -645,7 +645,7 @@
 	vm_page_t m = NULL;
 	struct vpgqueues *pq;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	pq = &vm_page_queues[basequeue];
 
 	/*
@@ -683,7 +683,7 @@
 {
 	vm_page_t m;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	while (TRUE) {
 		m = vm_page_list_find(
 		    PQ_CACHE,
@@ -735,7 +735,6 @@
  *	VM_ALLOC_INTERRUPT	interrupt time request
  *	VM_ALLOC_ZERO		zero page
  *
- *	vm_mtx must be locked.
  *	This routine may not block.
  *
  *	Additional special handling is required when called from an
@@ -752,7 +751,8 @@
 	register vm_page_t m = NULL;
 	int s;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	KASSERT(!vm_page_lookup(object, pindex),
 		("vm_page_alloc: page already allocated"));
 
@@ -885,13 +885,13 @@
 	s = splvm();
 	if (curproc == pageproc) {
 		vm_pageout_pages_needed = 1;
-		msleep(&vm_pageout_pages_needed, &vm_mtx, PSWP, "VMWait", 0);
+		tsleep(&vm_pageout_pages_needed, PSWP, "VMWait", 0);
 	} else {
 		if (!vm_pages_needed) {
 			vm_pages_needed = 1;
 			wakeup(&vm_pages_needed);
 		}
-		msleep(&cnt.v_free_count, &vm_mtx, PVM, "vmwait", 0);
+		tsleep(&cnt.v_free_count, PVM, "vmwait", 0);
 	}
 	splx(s);
 }
@@ -938,8 +938,9 @@
 {
 	int s;
 
+	GIANT_REQUIRED;
 	s = splvm();
-	mtx_assert(&vm_mtx, MA_OWNED);
+
 	if (m->queue != PQ_ACTIVE) {
 		if ((m->queue - m->pc) == PQ_CACHE)
 			cnt.v_reactivated++;
@@ -1012,9 +1013,8 @@
 	struct vpgqueues *pq;
 	vm_object_t object = m->object;
 
+	GIANT_REQUIRED;
 	s = splvm();
-
-	mtx_assert(&vm_mtx, MA_OWNED);
 	cnt.v_tfree++;
 
 	if (m->busy || ((m->queue - m->pc) == PQ_FREE) ||
@@ -1252,7 +1252,7 @@
 {
 	int s;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	/*
 	 * Ignore if already inactive.
 	 */
@@ -1290,8 +1290,8 @@
 int
 vm_page_try_to_cache(vm_page_t m)
 {
+	GIANT_REQUIRED;
 
-	mtx_assert(VM_PAGE_MTX(m), MA_OWNED);
 	if (m->dirty || m->hold_count || m->busy || m->wire_count ||
 	    (m->flags & (PG_BUSY|PG_UNMANAGED))) {
 		return(0);
@@ -1339,7 +1339,7 @@
 {
 	int s;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if ((m->flags & (PG_BUSY|PG_UNMANAGED)) || m->busy || m->wire_count) {
 		printf("vm_page_cache: attempting to cache busy page\n");
 		return;
@@ -1397,7 +1397,7 @@
 	int dnw;
 	int head;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	dnw = ++dnweight;
 
 	/*
@@ -1438,7 +1438,6 @@
  * to be in the object.  If the page doesn't exist, allocate it.
  *
  * This routine may block.
- * Requires vm_mtx.
  */
 vm_page_t
 vm_page_grab(object, pindex, allocflags)
@@ -1449,7 +1448,7 @@
 	vm_page_t m;
 	int s, generation;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 retrylookup:
 	if ((m = vm_page_lookup(object, pindex)) != NULL) {
 		if (m->busy || (m->flags & PG_BUSY)) {
@@ -1459,7 +1458,7 @@
 			while ((object->generation == generation) &&
 					(m->busy || (m->flags & PG_BUSY))) {
 				vm_page_flag_set(m, PG_WANTED | PG_REFERENCED);
-				msleep(m, &vm_mtx, PVM, "pgrbwt", 0);
+				tsleep(m, PVM, "pgrbwt", 0);
 				if ((allocflags & VM_ALLOC_RETRY) == 0) {
 					splx(s);
 					return NULL;
@@ -1522,8 +1521,6 @@
  *	This routine may not block.
  *
  *	(base + size) must be less then or equal to PAGE_SIZE.
- *
- *	vm_mtx needs to be held
  */
 void
 vm_page_set_validclean(m, base, size)
@@ -1535,7 +1532,7 @@
 	int frag;
 	int endoff;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if (size == 0)	/* handle degenerate case */
 		return;
 
@@ -1609,8 +1606,7 @@
 	int base;
 	int size;
 {
-
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	m->dirty &= ~vm_page_bits(base, size);
 }
 
@@ -1630,7 +1626,7 @@
 {
 	int bits;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	bits = vm_page_bits(base, size);
 	m->valid &= ~bits;
 	m->dirty &= ~bits;
@@ -1918,16 +1914,10 @@
 	unsigned long boundary;
 {
 	void * ret;
-	int hadvmlock;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
 	ret = contigmalloc1(size, type, flags, low, high, alignment, boundary,
 			     kernel_map);
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
-
 	return (ret);
 
 }
@@ -1938,14 +1928,8 @@
 	unsigned long size;
 	struct malloc_type *type;
 {
-	int hadvmlock;
-
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
 	kmem_free(kernel_map, (vm_offset_t)addr, size);
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 }
 
 vm_offset_t
@@ -1956,15 +1940,10 @@
 	vm_offset_t alignment;
 {
 	vm_offset_t ret;
-	int hadvmlock;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
 	ret = ((vm_offset_t)contigmalloc1(size, M_DEVBUF, M_NOWAIT, low, high,
 					  alignment, 0ul, kernel_map));
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	return (ret);
 
 }
Index: vm/vm_page.h
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_page.h,v
retrieving revision 1.86
diff -u -r1.86 vm_page.h
--- vm/vm_page.h	2001/05/24 07:22:26	1.86
+++ vm/vm_page.h	2001/07/04 02:54:17
@@ -305,28 +305,23 @@
 		(&vm_page_array[atop(pa) - first_page ])
 
 /*
- * For now, a global vm lock
- */
-#define	VM_PAGE_MTX(m)	(&vm_mtx)
-
-/*
  *	Functions implemented as macros
  */
 
 static __inline void
 vm_page_flag_set(vm_page_t m, unsigned short bits)
 {
-
-	mtx_assert(VM_PAGE_MTX(m), MA_OWNED);
-	m->flags |= bits;
+	GIANT_REQUIRED;
+	atomic_set_short(&(m)->flags, bits);
+	/* m->flags |= bits; */
 }
 
 static __inline void
 vm_page_flag_clear(vm_page_t m, unsigned short bits)
 {
-
-	mtx_assert(VM_PAGE_MTX(m), MA_OWNED);
-	m->flags &= ~bits;
+	GIANT_REQUIRED;
+	atomic_clear_short(&(m)->flags, bits);
+	/* m->flags &= ~bits; */
 }
 
 #if 0
@@ -386,17 +381,15 @@
 static __inline void
 vm_page_io_start(vm_page_t m)
 {
-
-	mtx_assert(VM_PAGE_MTX(m), MA_OWNED);
-	m->busy++;
+	GIANT_REQUIRED;
+	atomic_add_char(&(m)->busy, 1);
 }
 
 static __inline void
 vm_page_io_finish(vm_page_t m)
 {
-
-	mtx_assert(VM_PAGE_MTX(m), MA_OWNED);
-	m->busy--;
+	GIANT_REQUIRED;
+	atomic_subtract_char(&(m)->busy, 1);
 	if (m->busy == 0)
 		vm_page_flash(m);
 }
@@ -463,16 +456,14 @@
 static __inline void
 vm_page_hold(vm_page_t mem)
 {
-
-	mtx_assert(VM_PAGE_MTX(m), MA_OWNED);
+	GIANT_REQUIRED;
 	mem->hold_count++;
 }
 
 static __inline void
 vm_page_unhold(vm_page_t mem)
 {
-
-	mtx_assert(VM_PAGE_MTX(m), MA_OWNED);
+	GIANT_REQUIRED;
 	--mem->hold_count;
 	KASSERT(mem->hold_count >= 0, ("vm_page_unhold: hold count < 0!!!"));
 }
@@ -578,6 +569,7 @@
 static __inline int
 vm_page_sleep_busy(vm_page_t m, int also_m_busy, const char *msg)
 {
+	GIANT_REQUIRED;
 	if ((m->flags & PG_BUSY) || (also_m_busy && m->busy))  {
 		int s = splvm();
 		if ((m->flags & PG_BUSY) || (also_m_busy && m->busy)) {
@@ -585,7 +577,7 @@
 			 * Page is busy. Wait and retry.
 			 */
 			vm_page_flag_set(m, PG_WANTED | PG_REFERENCED);
-			msleep(m, VM_PAGE_MTX(m), PVM, msg, 0);
+			tsleep(m, PVM, msg, 0);
 		}
 		splx(s);
 		return(TRUE);
Index: vm/vm_pageout.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_pageout.c,v
retrieving revision 1.179
diff -u -r1.179 vm_pageout.c
--- vm/vm_pageout.c	2001/06/20 23:34:06	1.179
+++ vm/vm_pageout.c	2001/07/04 02:54:17
@@ -226,7 +226,8 @@
 	int ib, is, page_base;
 	vm_pindex_t pindex = m->pindex;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	object = m->object;
 
 	/*
@@ -366,7 +367,7 @@
 	int numpagedout = 0;
 	int i;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	/*
 	 * Initiate I/O.  Bump the vm_page_t->busy counter and
 	 * mark the pages read-only.
@@ -449,8 +450,6 @@
  *	backing_objects.
  *
  *	The object and map must be locked.
- *
- *	Requires the vm_mtx
  */
 static void
 vm_pageout_object_deactivate_pages(map, object, desired, map_remove_only)
@@ -464,7 +463,7 @@
 	int remove_mode;
 	int s;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if (object->type == OBJT_DEVICE || object->type == OBJT_PHYS)
 		return;
 
@@ -553,7 +552,7 @@
 	vm_map_entry_t tmpe;
 	vm_object_t obj, bigobj;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if (lockmgr(&map->lock, LK_EXCLUSIVE | LK_NOWAIT, (void *)0, curproc)) {
 		return;
 	}
@@ -619,7 +618,7 @@
 	vm_object_t object = m->object;
 	int type = object->type;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if (type == OBJT_SWAP || type == OBJT_DEFAULT)
 		vm_object_reference(object);
 	vm_page_busy(m);
@@ -649,8 +648,7 @@
 	int maxlaunder;
 	int s;
 
-	mtx_assert(&Giant, MA_OWNED);
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	/*
 	 * Do whatever cleanup that the pmap code can.
 	 */
@@ -878,17 +876,14 @@
 				vp = object->handle;
 
 				mp = NULL;
-				mtx_unlock(&vm_mtx);
 				if (vp->v_type == VREG)
 					vn_start_write(vp, &mp, V_NOWAIT);
 				if (vget(vp, LK_EXCLUSIVE|LK_NOOBJ, curproc)) {
 					vn_finished_write(mp);
-					mtx_lock(&vm_mtx);
 					if (object->flags & OBJ_MIGHTBEDIRTY)
 						vnodes_skipped++;
 					continue;
 				}
-				mtx_lock(&vm_mtx);
 
 				/*
 				 * The page might have been moved to another
@@ -902,10 +897,8 @@
 				    object->handle != vp) {
 					if (object->flags & OBJ_MIGHTBEDIRTY)
 						vnodes_skipped++;
-					mtx_unlock(&vm_mtx);
 					vput(vp);
 					vn_finished_write(mp);
-					mtx_lock(&vm_mtx);
 					continue;
 				}
 	
@@ -916,10 +909,8 @@
 				 * statistics are more correct if we don't.
 				 */
 				if (m->busy || (m->flags & PG_BUSY)) {
-					mtx_unlock(&vm_mtx);
 					vput(vp);
 					vn_finished_write(mp);
-					mtx_lock(&vm_mtx);
 					continue;
 				}
 
@@ -933,10 +924,8 @@
 					splx(s);
 					if (object->flags & OBJ_MIGHTBEDIRTY)
 						vnodes_skipped++;
-					mtx_unlock(&vm_mtx);
 					vput(vp);
 					vn_finished_write(mp);
-					mtx_lock(&vm_mtx);
 					continue;
 				}
 			}
@@ -967,10 +956,8 @@
 			TAILQ_REMOVE(&vm_page_queues[PQ_INACTIVE].pl, &marker, pageq);
 			splx(s);
 			if (vp) {
-				mtx_unlock(&vm_mtx);
 				vput(vp);
 				vn_finished_write(mp);
-				mtx_lock(&vm_mtx);
 			}
 		}
 	}
@@ -1154,11 +1141,9 @@
 #if 0
 	if ((vm_swap_size < 64 || swap_pager_full) && vm_page_count_min()) {
 #endif
-		mtx_unlock(&vm_mtx);
 		bigproc = NULL;
 		bigsize = 0;
 		sx_slock(&allproc_lock);
-		mtx_lock(&vm_mtx);
 		LIST_FOREACH(p, &allproc, p_list) {
 			/*
 			 * If this process is already locked, skip it.
@@ -1350,7 +1335,6 @@
 	int pass;
 
 	mtx_lock(&Giant);
-	mtx_lock(&vm_mtx);
 
 	/*
 	 * Initialize some paging parameters.
@@ -1410,7 +1394,6 @@
 	 */
 	if (vm_pageout_stats_free_max == 0)
 		vm_pageout_stats_free_max = 5;
-	mtx_unlock(&vm_mtx);
 
 	PROC_LOCK(curproc);
 	curproc->p_flag |= P_BUFEXHAUST;
@@ -1420,7 +1403,6 @@
 	/*
 	 * The pageout daemon is never done, so loop forever.
 	 */
-	mtx_lock(&vm_mtx);
 	while (TRUE) {
 		int error;
 		int s = splvm();
@@ -1444,7 +1426,7 @@
 			 */
 			++pass;
 			if (pass > 1)
-				msleep(&vm_pages_needed, &vm_mtx, PVM,
+				tsleep(&vm_pages_needed, PVM,
 				       "psleep", hz/2);
 		} else {
 			/*
@@ -1455,8 +1437,8 @@
 				pass = 1;
 			else
 				pass = 0;
-			error = msleep(&vm_pages_needed, &vm_mtx,
-				PVM, "psleep", vm_pageout_stats_interval * hz);
+			error = tsleep(&vm_pages_needed, PVM,
+				    "psleep", vm_pageout_stats_interval * hz);
 			if (error && !vm_pages_needed) {
 				splx(s);
 				pass = 0;
@@ -1501,14 +1483,11 @@
 
 	mtx_lock(&Giant);
 	while (TRUE) {
-		mtx_lock(&vm_mtx);
-		msleep(&vm_daemon_needed, &vm_mtx, PPAUSE, "psleep", 0);
+		tsleep(&vm_daemon_needed, PPAUSE, "psleep", 0);
 		if (vm_pageout_req_swapout) {
 			swapout_procs(vm_pageout_req_swapout);
-			mtx_assert(&vm_mtx, MA_OWNED);
 			vm_pageout_req_swapout = 0;
 		}
-		mtx_unlock(&vm_mtx);
 		/*
 		 * scan the processes for exceeding their rlimits or if
 		 * process is swapped out -- deactivate pages
@@ -1525,7 +1504,6 @@
 			if (p->p_flag & (P_SYSTEM | P_WEXIT)) {
 				continue;
 			}
-			mtx_lock(&vm_mtx);
 			/*
 			 * if the process is in a non-running type state,
 			 * don't touch it.
@@ -1533,7 +1511,6 @@
 			mtx_lock_spin(&sched_lock);
 			if (p->p_stat != SRUN && p->p_stat != SSLEEP) {
 				mtx_unlock_spin(&sched_lock);
-				mtx_unlock(&vm_mtx);
 				continue;
 			}
 			/*
@@ -1557,7 +1534,6 @@
 				vm_pageout_map_deactivate_pages(
 				    &p->p_vmspace->vm_map, limit);
 			}
-			mtx_unlock(&vm_mtx);
 		}
 		sx_sunlock(&allproc_lock);
 	}
Index: vm/vm_pager.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_pager.c,v
retrieving revision 1.71
diff -u -r1.71 vm_pager.c
--- vm/vm_pager.c	2001/05/19 01:28:09	1.71
+++ vm/vm_pager.c	2001/07/04 02:54:17
@@ -245,18 +245,14 @@
 {
 	vm_object_t ret;
 	struct pagerops *ops;
-	int hadvmlock;
 
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
+	GIANT_REQUIRED;
+
 	ops = pagertab[type];
 	if (ops)
 		ret = (*ops->pgo_alloc) (handle, size, prot, off);
 	else
 		ret = NULL;
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	return (ret);
 }
 
@@ -264,8 +260,7 @@
 vm_pager_deallocate(object)
 	vm_object_t object;
 {
-
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	(*pagertab[object->type]->pgo_dealloc) (object);
 }
 
@@ -385,8 +380,6 @@
  *
  *	NOTE: pfreecnt can be NULL, but this 'feature' will be removed
  *	relatively soon when the rest of the subsystems get smart about it. XXX
- *
- *	vm_mtx can be held or unheld
  */
 struct buf *
 getpbuf(pfreecnt)
@@ -394,12 +387,9 @@
 {
 	int s;
 	struct buf *bp;
-	int hadvmlock;
 
 	s = splvm();
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (hadvmlock)
-		mtx_unlock(&vm_mtx);
+	GIANT_REQUIRED;
 	mtx_lock(&pbuf_mtx);
 
 	for (;;) {
@@ -424,8 +414,6 @@
 	splx(s);
 
 	initpbuf(bp);
-	if (hadvmlock)
-		mtx_lock(&vm_mtx);
 	return bp;
 }
 
Index: vm/vm_pager.h
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_pager.h,v
retrieving revision 1.32
diff -u -r1.32 vm_pager.h
--- vm/vm_pager.h	2001/05/19 01:28:09	1.32
+++ vm/vm_pager.h	2001/07/04 02:54:17
@@ -124,12 +124,12 @@
 ) {
 	int r;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
+
 	r = (*pagertab[object->type]->pgo_getpages)(object, m, count, reqpage);
 	if (r == VM_PAGER_OK && m[reqpage]->valid != VM_PAGE_BITS_ALL) {
 		vm_page_zero_invalid(m[reqpage], TRUE);
 	}
-	mtx_assert(&vm_mtx, MA_OWNED);
 	return(r);
 }
 
@@ -141,11 +141,9 @@
 	int flags,
 	int *rtvals
 ) {
-
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	(*pagertab[object->type]->pgo_putpages)
 	    (object, m, count, flags, rtvals);
-	mtx_assert(&vm_mtx, MA_OWNED);
 }
 
 /*
@@ -168,10 +166,9 @@
 ) {
 	boolean_t ret;
 
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	ret = (*pagertab[object->type]->pgo_haspage)
 	    (object, offset, before, after);
-	mtx_assert(&vm_mtx, MA_OWNED);
 	return (ret);
 } 
 
@@ -186,11 +183,9 @@
 static __inline void
 vm_pager_page_unswapped(vm_page_t m)
 {
-
-	mtx_assert(&vm_mtx, MA_OWNED);
+	GIANT_REQUIRED;
 	if (pagertab[m->object->type]->pgo_pageunswapped)
 		(*pagertab[m->object->type]->pgo_pageunswapped)(m);
-	mtx_assert(&vm_mtx, MA_OWNED);
 }
 
 #endif
Index: vm/vm_unix.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_unix.c,v
retrieving revision 1.32
diff -u -r1.32 vm_unix.c
--- vm/vm_unix.c	2001/05/24 18:04:29	1.32
+++ vm/vm_unix.c	2001/07/04 02:54:17
@@ -74,7 +74,10 @@
 	register struct vmspace *vm = p->p_vmspace;
 	vm_offset_t new, old, base;
 	int rv;
+	int error = 0;
 
+	mtx_lock(&Giant);	/* syscall marked mp-safe but isn't */
+
 	base = round_page((vm_offset_t) vm->vm_daddr);
 	new = round_page((vm_offset_t)uap->nsize);
 	old = base + ctob(vm->vm_dsize);
@@ -84,52 +87,46 @@
 		 * reduce their usage, even if they remain over the limit.
 		 */
 		if (new > old &&
-		    (new - base) > (unsigned) p->p_rlimit[RLIMIT_DATA].rlim_cur)
-			return ENOMEM;
-		if (new >= VM_MAXUSER_ADDRESS)
-			return (ENOMEM);
+		    (new - base) > (unsigned) p->p_rlimit[RLIMIT_DATA].rlim_cur) {
+			error = ENOMEM;
+			goto done;
+		}
+		if (new >= VM_MAXUSER_ADDRESS) {
+			error = ENOMEM;
+			goto done;
+		}
 	} else if (new < base) {
 		/*
 		 * This is simply an invalid value.  If someone wants to
 		 * do fancy address space manipulations, mmap and munmap
 		 * can do most of what the user would want.
 		 */
-		return EINVAL;
+		error = EINVAL;
+		goto done;
 	}
 
 	if (new > old) {
 		vm_size_t diff;
 
 		diff = new - old;
-#ifndef BLEED
-		mtx_lock(&Giant);
-#endif
-		mtx_lock(&vm_mtx);
 		rv = vm_map_find(&vm->vm_map, NULL, 0, &old, diff, FALSE,
 			VM_PROT_ALL, VM_PROT_ALL, 0);
 		if (rv != KERN_SUCCESS) {
-			mtx_unlock(&vm_mtx);
-			return (ENOMEM);
+			error = ENOMEM;
+			goto done;
 		}
 		vm->vm_dsize += btoc(diff);
-		mtx_unlock(&vm_mtx);
-#ifndef BLEED
-		mtx_unlock(&Giant);
-#endif
 	} else if (new < old) {
-		mtx_lock(&Giant);
-		mtx_lock(&vm_mtx);
 		rv = vm_map_remove(&vm->vm_map, new, old);
 		if (rv != KERN_SUCCESS) {
-			mtx_unlock(&vm_mtx);
-			mtx_unlock(&Giant);
-			return (ENOMEM);
+			error = ENOMEM;
+			goto done;
 		}
 		vm->vm_dsize -= btoc(old - new);
-		mtx_unlock(&vm_mtx);
-		mtx_unlock(&Giant);
 	}
-	return (0);
+done:
+	mtx_unlock(&Giant);
+	return (error);
 }
 
 #ifndef _SYS_SYSPROTO_H_
@@ -144,6 +141,7 @@
 	struct proc *p;
 	struct ovadvise_args *uap;
 {
-
+	/* START_GIANT_OPTIONAL */
+	/* END_GIANT_OPTIONAL */
 	return (EINVAL);
 }
Index: vm/vm_zone.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vm_zone.c,v
retrieving revision 1.44
diff -u -r1.44 vm_zone.c
--- vm/vm_zone.c	2001/05/19 01:28:09	1.44
+++ vm/vm_zone.c	2001/07/04 02:54:17
@@ -19,6 +19,7 @@
 #include <sys/kernel.h>
 #include <sys/lock.h>
 #include <sys/malloc.h>
+#include <sys/proc.h>
 #include <sys/mutex.h>
 #include <sys/queue.h>
 #include <sys/sysctl.h>
@@ -119,6 +120,8 @@
 {
 	int totsize, oldzflags;
 
+	GIANT_REQUIRED;
+
 	oldzflags = z->zflags;
 	if ((z->zflags & ZONE_BOOT) == 0) {
 		z->zsize = (size + ZONE_ROUNDING - 1) & ~(ZONE_ROUNDING - 1);
@@ -137,8 +140,6 @@
 	 * in pages as needed.
 	 */
 	if (z->zflags & ZONE_INTERRUPT) {
-		int hadvmlock;
-
 		totsize = round_page(z->zsize * nentries);
 		atomic_add_int(&zone_kmem_kvaspace, totsize);
 		z->zkva = kmem_alloc_pageable(kernel_map, totsize);
@@ -146,17 +147,12 @@
 			return 0;
 
 		z->zpagemax = totsize / PAGE_SIZE;
-		hadvmlock = mtx_owned(&vm_mtx);
-		if (!hadvmlock)
-			mtx_lock(&vm_mtx);
 		if (obj == NULL) {
 			z->zobj = vm_object_allocate(OBJT_DEFAULT, z->zpagemax);
 		} else {
 			z->zobj = obj;
 			_vm_object_allocate(OBJT_DEFAULT, z->zpagemax, obj);
 		}
-		if (!hadvmlock)
-			mtx_unlock(&vm_mtx);
 		z->zallocflag = VM_ALLOC_INTERRUPT;
 		z->zmax += nentries;
 	} else {
@@ -364,12 +360,8 @@
 zalloc(vm_zone_t z)
 {
 	void *item;
-	int hadvmlock;
 
 	KASSERT(z != NULL, ("invalid zone"));
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
 	mtx_lock(&z->zmtx);
 	
 	if (z->zfreecnt <= z->zfreemin) {
@@ -390,8 +382,6 @@
 
 out:	
 	mtx_unlock(&z->zmtx);
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	return item;
 }
 
@@ -401,13 +391,8 @@
 void
 zfree(vm_zone_t z, void *item)
 {
-	int hadvmlock;
-
 	KASSERT(z != NULL, ("invalid zone"));
 	KASSERT(item != NULL, ("invalid item"));
-	hadvmlock = mtx_owned(&vm_mtx);
-	if (!hadvmlock)
-		mtx_lock(&vm_mtx);
 	mtx_lock(&z->zmtx);
 	
 	((void **) item)[0] = z->zitems;
@@ -419,8 +404,6 @@
 	z->zitems = item;
 	z->zfreecnt++;
 
-	if (!hadvmlock)
-		mtx_unlock(&vm_mtx);
 	mtx_unlock(&z->zmtx);
 }
 
Index: vm/vnode_pager.c
===================================================================
RCS file: /home/ncvs/src/sys/vm/vnode_pager.c,v
retrieving revision 1.132
diff -u -r1.132 vnode_pager.c
--- vm/vnode_pager.c	2001/07/03 07:35:56	1.132
+++ vm/vnode_pager.c	2001/07/04 02:54:17
@@ -110,7 +110,8 @@
 	vm_object_t object;
 	struct vnode *vp;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
+
 	/*
 	 * Pageout to vnode, no can do yet.
 	 */
@@ -123,13 +124,11 @@
 	 * Prevent race condition when allocating the object. This
 	 * can happen with NFS vnodes since the nfsnode isn't locked.
 	 */
-	mtx_unlock(&vm_mtx);
 	while (vp->v_flag & VOLOCK) {
 		vp->v_flag |= VOWANT;
 		tsleep(vp, PVM, "vnpobj", 0);
 	}
 	vp->v_flag |= VOLOCK;
-	mtx_lock(&vm_mtx);
 
 	/*
 	 * If the object is being terminated, wait for it to
@@ -137,7 +136,7 @@
 	 */
 	while (((object = vp->v_object) != NULL) &&
 		(object->flags & OBJ_DEAD)) {
-		msleep(object, &vm_mtx, PVM, "vadead", 0);
+		tsleep(object, PVM, "vadead", 0);
 	}
 
 	if (vp->v_usecount == 0)
@@ -160,13 +159,11 @@
 		vp->v_usecount++;
 	}
 
-	mtx_unlock(&vm_mtx);
 	vp->v_flag &= ~VOLOCK;
 	if (vp->v_flag & VOWANT) {
 		vp->v_flag &= ~VOWANT;
 		wakeup(vp);
 	}
-	mtx_lock(&vm_mtx);
 	return (object);
 }
 
@@ -176,7 +173,7 @@
 {
 	register struct vnode *vp = object->handle;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	if (vp == NULL)
 		panic("vnode_pager_dealloc: pager already dealloced");
 
@@ -203,7 +200,7 @@
 	int bsize;
 	int pagesperblock, blocksperpage;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	/*
 	 * If no vp or vp is doomed or marked transparent to VM, we do not
 	 * have the page.
@@ -228,10 +225,8 @@
 		blocksperpage = (PAGE_SIZE / bsize);
 		reqblock = pindex * blocksperpage;
 	}
-	mtx_unlock(&vm_mtx);
 	err = VOP_BMAP(vp, reqblock, (struct vnode **) 0, &bn,
 		after, before);
-	mtx_lock(&vm_mtx);
 	if (err)
 		return TRUE;
 	if ( bn == -1)
@@ -279,6 +274,8 @@
 	vm_pindex_t nobjsize;
 	vm_object_t object = vp->v_object;
 
+	GIANT_REQUIRED;
+
 	if (object == NULL)
 		return;
 
@@ -294,11 +291,6 @@
 	 * File has shrunk. Toss any cached pages beyond the new EOF.
 	 */
 	if (nsize < object->un_pager.vnp.vnp_size) {
-		int hadvmlock;
-
-		hadvmlock = mtx_owned(&vm_mtx);
-		if (!hadvmlock)
-			mtx_lock(&vm_mtx);
 		vm_freeze_copyopts(object, OFF_TO_IDX(nsize), object->size);
 		if (nobjsize < object->size) {
 			vm_object_page_remove(object, nobjsize, object->size,
@@ -339,8 +331,6 @@
 					m->dirty = VM_PAGE_BITS_ALL;
 			}
 		}
-		if (!hadvmlock)
-			mtx_unlock(&vm_mtx);
 	}
 	object->un_pager.vnp.vnp_size = nsize;
 	object->size = nobjsize;
@@ -364,7 +354,7 @@
 	daddr_t vblock;
 	int voffset;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	if ((int) address < 0)
 		return -1;
 
@@ -374,11 +364,9 @@
 	bsize = vp->v_mount->mnt_stat.f_iosize;
 	vblock = address / bsize;
 	voffset = address % bsize;
-	mtx_unlock(&vm_mtx);
 
 	err = VOP_BMAP(vp, vblock, &rtvp, &block, run, NULL);
 
-	mtx_lock(&vm_mtx);
 	if (err || (block == -1))
 		rtaddress = -1;
 	else {
@@ -421,17 +409,16 @@
 	vm_offset_t bsize;
 	int error = 0;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
+
 	vp = object->handle;
 	if (vp->v_mount == NULL)
 		return VM_PAGER_BAD;
 
 	bsize = vp->v_mount->mnt_stat.f_iosize;
-	mtx_unlock(&vm_mtx);
 
 	VOP_BMAP(vp, 0, &dp, 0, NULL, NULL);
 
-	mtx_lock(&vm_mtx);
 	kva = vm_pager_map_page(m);
 
 	for (i = 0; i < PAGE_SIZE / bsize; i++) {
@@ -442,7 +429,6 @@
 		fileaddr = vnode_pager_addr(vp,
 			IDX_TO_OFF(m->pindex) + i * bsize, (int *)0);
 		if (fileaddr != -1) {
-			mtx_unlock(&vm_mtx);
 			bp = getpbuf(&vnode_pbuf_freecnt);
 
 			/* build a minimal buffer header */
@@ -478,7 +464,6 @@
 			 * free the buffer header back to the swap buffer pool
 			 */
 			relpbuf(bp, &vnode_pbuf_freecnt);
-			mtx_lock(&vm_mtx);
 			if (error)
 				break;
 
@@ -514,7 +499,7 @@
 	vm_offset_t kva;
 	struct vnode *vp;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	error = 0;
 
 	/*
@@ -534,7 +519,6 @@
 		kva = vm_pager_map_page(m);
 
 		vp = object->handle;
-		mtx_unlock(&vm_mtx);
 		aiov.iov_base = (caddr_t) kva;
 		aiov.iov_len = size;
 		auio.uio_iov = &aiov;
@@ -554,7 +538,6 @@
 			else if (count != PAGE_SIZE)
 				bzero((caddr_t) kva + count, PAGE_SIZE - count);
 		}
-		mtx_lock(&vm_mtx);
 		vm_pager_unmap_page(kva);
 	}
 	pmap_clear_modify(m);
@@ -588,7 +571,7 @@
 	struct vnode *vp;
 	int bytes = count * PAGE_SIZE;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	vp = object->handle;
 	rtval = VOP_GETPAGES(vp, m, bytes, reqpage, 0);
 	KASSERT(rtval != EOPNOTSUPP,
@@ -620,7 +603,7 @@
 	int count;
 	int error = 0;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	object = vp->v_object;
 	count = bytecount / PAGE_SIZE;
 
@@ -640,9 +623,7 @@
 	/*
 	 * if we can't bmap, use old VOP code
 	 */
-	mtx_unlock(&vm_mtx);
 	if (VOP_BMAP(vp, 0, &dp, 0, NULL, NULL)) {
-		mtx_lock(&vm_mtx);
 		for (i = 0; i < count; i++) {
 			if (i != reqpage) {
 				vm_page_free(m[i]);
@@ -659,7 +640,6 @@
 		 */
 	} else if ((PAGE_SIZE / bsize) > 1 &&
 	    (vp->v_mount->mnt_stat.f_type != nfs_mount_type)) {
-		mtx_lock(&vm_mtx);
 		for (i = 0; i < count; i++) {
 			if (i != reqpage) {
 				vm_page_free(m[i]);
@@ -669,7 +649,6 @@
 		cnt.v_vnodepgsin++;
 		return vnode_pager_input_smlfs(object, m[reqpage]);
 	}
-	mtx_lock(&vm_mtx);
 
 	/*
 	 * If we have a completely valid page available to us, we can
@@ -770,7 +749,6 @@
 	 * and map the pages to be read into the kva
 	 */
 	pmap_qenter(kva, m, count);
-	mtx_unlock(&vm_mtx);
 
 	/* build a minimal buffer header */
 	bp->b_iocmd = BIO_READ;
@@ -808,7 +786,6 @@
 		if (size != count * PAGE_SIZE)
 			bzero((caddr_t) kva + size, PAGE_SIZE * count - size);
 	}
-	mtx_lock(&vm_mtx);
 	pmap_qremove(kva, count);
 
 	/*
@@ -899,7 +876,7 @@
 	struct mount *mp;
 	int bytes = count * PAGE_SIZE;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	/*
 	 * Force synchronous operation if we are extremely low on memory
 	 * to prevent a low-memory deadlock.  VOP operations often need to
@@ -920,17 +897,13 @@
 	 */
 
 	vp = object->handle;
-	mtx_unlock(&vm_mtx);
 	if (vp->v_type != VREG)
 		mp = NULL;
 	(void)vn_start_write(vp, &mp, V_WAIT);
-	mtx_lock(&vm_mtx);
 	rtval = VOP_PUTPAGES(vp, m, bytes, sync, rtvals, 0);
 	KASSERT(rtval != EOPNOTSUPP, 
 	    ("vnode_pager: stale FS putpages\n"));
-	mtx_unlock(&vm_mtx);
 	vn_finished_write(mp);
-	mtx_lock(&vm_mtx);
 }
 
 
@@ -962,7 +935,7 @@
 	int error;
 	int ioflags;
 
-	mtx_assert(&Giant, MA_OWNED);
+	GIANT_REQUIRED;
 	object = vp->v_object;
 	count = bytecount / PAGE_SIZE;
 
@@ -992,7 +965,6 @@
 			}
 		}
 	}
-	mtx_unlock(&vm_mtx);
 
 	/*
 	 * pageouts are already clustered, use IO_ASYNC t o force a bawrite()
@@ -1013,7 +985,6 @@
 	auio.uio_resid = maxsize;
 	auio.uio_procp = (struct proc *) 0;
 	error = VOP_WRITE(vp, &auio, ioflags, curproc->p_ucred);
-	mtx_lock(&vm_mtx);
 	cnt.v_vnodeout++;
 	cnt.v_vnodepgsout += ncount;
 
@@ -1035,19 +1006,16 @@
 	vm_object_t object;
 {
 	struct proc *p = curproc;	/* XXX */
+
+	GIANT_REQUIRED;
 
-	mtx_assert(&vm_mtx, MA_NOTOWNED);
-	mtx_assert(&Giant, MA_OWNED);
-	mtx_lock(&vm_mtx);
 	for (; object != NULL; object = object->backing_object) {
 		if (object->type != OBJT_VNODE)
 			continue;
 		if (object->flags & OBJ_DEAD) {
-			mtx_unlock(&vm_mtx);
 			return NULL;
 		}
 
-		mtx_unlock(&vm_mtx);
 		/* XXX; If object->handle can change, we need to cache it. */
 		while (vget(object->handle,
 			LK_NOPAUSE | LK_SHARED | LK_RETRY | LK_CANRECURSE, p)) {
@@ -1057,6 +1025,5 @@
 		}
 		return object->handle;
 	}
-	mtx_unlock(&vm_mtx);
 	return NULL;
 }
